﻿local L = HunterAEP.L

---------------------------------------------------------------------------------------
-- Fires on main frame events
---------------------------------------------------------------------------------------
function HunterAEPOptionsFrame_OnEvent()
--	if(HunterAEPOptions.AtlasRightClick) then
--		HunterAEPOptions.AtlasRightClick = false;
--	else
--		HunterAEPOptions.AtlasRightClick = true;
--	end
--	HunterAEPOptions_Init();
end

---------------------------------------------------------------------------------------
-- Fires every time the config window is launched
---------------------------------------------------------------------------------------
function HunterAEPOptionsFrame_Load()
	PlaySound("igMainMenuOpen")

	HunterAEPOptionsFrameGeneralEnabled:SetChecked(HunterAEP:IsActive())
	HunterAEPOptions_SetupEditBoxes()
end

---------------------------------------------------------------------------------------
-- Used to populate edit boxes and total box.  Called during load and a default reset
---------------------------------------------------------------------------------------
function HunterAEPOptions_SetupEditBoxes()
	HunterAEPOptionsFrameGeneralTotal:SetChecked(HunterAEP.db.profile["TotalDisplayed"])

	HunterAEPOptionsFrameAttributeWeightsEditAgi:SetNumber(HunterAEP.db.profile["AGI"])
	HunterAEPOptionsFrameAttributeWeightsEditInt:SetNumber(HunterAEP.db.profile["INT"])
	HunterAEPOptionsFrameAttributeWeightsEditAP:SetNumber(HunterAEP.db.profile["ATTACKPOWER"])
	HunterAEPOptionsFrameAttributeWeightsEditHR:SetNumber(HunterAEP.db.profile["CR_HIT"])
	HunterAEPOptionsFrameAttributeWeightsEditCR:SetNumber(HunterAEP.db.profile["CR_CRIT"])
	HunterAEPOptionsFrameAttributeWeightsEditMP5:SetNumber(HunterAEP.db.profile["MANAREG"])
	HunterAEPOptionsFrameAttributeWeightsEditSta:SetNumber(HunterAEP.db.profile["STA"])
	HunterAEPOptionsFrameAttributeWeightsEditRR:SetNumber(HunterAEP.db.profile["CR_RESILIENCE"])
end

---------------------------------------------------------------------------------------
-- Fires when addon is first initialized
---------------------------------------------------------------------------------------
function HunterAEPOptionsFrame_Init()
	--Allows frame to be closed with the Escape key
	tinsert(UISpecialFrames, "HunterAEPOptionsFrame")

	--Dragging involves some special registration
	HunterAEPOptionsFrame:RegisterForDrag("LeftButton");

	-- setup header text to be localized and correct width
	HunterAEPOptionsFrameHeaderFS:SetText(L["HunterAEP Options"])
	HunterAEPOptionsFrameHeader:SetWidth(HunterAEPOptionsFrameHeaderFS:GetStringWidth() + 215)

	HunterAEPOptionsFrameAttributeWeightsFSAgi:SetText(L["Agility"])
	HunterAEPOptionsFrameAttributeWeightsFSInt:SetText(L["Intellect"])
	HunterAEPOptionsFrameAttributeWeightsFSAP:SetText(L["Attack Power"])
	HunterAEPOptionsFrameAttributeWeightsFSHR:SetText(L["Hit Rating"])
	HunterAEPOptionsFrameAttributeWeightsFSCR:SetText(L["Critical Strike Rating"])
	HunterAEPOptionsFrameAttributeWeightsFSMP5:SetText(L["Mana per 5 sec."])
	HunterAEPOptionsFrameAttributeWeightsFSSta:SetText(L["Stamina"])
	HunterAEPOptionsFrameAttributeWeightsFSRR:SetText(L["Resilience Rating"])
end

---------------------------------------------------------------------------------------
-- Fires when the user clicks save.  Just save all the options down to the profile and/or
-- modify the running addon.
---------------------------------------------------------------------------------------
function HunterAEPOptionsFrame_Save()
	-- enable or disable the addon
	HunterAEP:ToggleActive(HunterAEPOptions_CheckToBool(HunterAEPOptionsFrameGeneralEnabled))

	-- enable or disable the total
	HunterAEP.db.profile["TotalDisplayed"]=HunterAEPOptions_CheckToBool(HunterAEPOptionsFrameGeneralTotal)

	-- set values
	HunterAEP.db.profile["AGI"] = HunterAEPOptionsFrameAttributeWeightsEditAgi:GetNumber()
	HunterAEP.db.profile["INT"] = HunterAEPOptionsFrameAttributeWeightsEditInt:GetNumber()
	HunterAEP.db.profile["ATTACKPOWER"] = HunterAEPOptionsFrameAttributeWeightsEditAP:GetNumber()
	HunterAEP.db.profile["CR_HIT"] = HunterAEPOptionsFrameAttributeWeightsEditHR:GetNumber()
	HunterAEP.db.profile["CR_CRIT"] = HunterAEPOptionsFrameAttributeWeightsEditCR:GetNumber()
	HunterAEP.db.profile["MANAREG"] = HunterAEPOptionsFrameAttributeWeightsEditMP5:GetNumber()
	HunterAEP.db.profile["STA"] = HunterAEPOptionsFrameAttributeWeightsEditSta:GetNumber()
	HunterAEP.db.profile["CR_RESILIENCE"] = HunterAEPOptionsFrameAttributeWeightsEditRR:GetNumber()
end

---------------------------------------------------------------------------------------
-- Fires when the user clicks defaults.  This will reset all the edit boxes back to their
-- default values, user still has to click ok
---------------------------------------------------------------------------------------
function HunterAEPOptionsFrame_SetDefaults()
	HunterAEPOptionsFrameGeneralEnabled:SetChecked(true)
	HunterAEP:ResetDB("profile")
	HunterAEPOptions_SetupEditBoxes()
end

---------------------------------------------------------------------------------------
-- Fires when the window closes
---------------------------------------------------------------------------------------
function HunterAEPOptionsFrame_Cancel()
end

---------------------------------------------------------------------------------------
-- Coverts the given checkbox into a bool value depending on check state
---------------------------------------------------------------------------------------
function HunterAEPOptions_CheckToBool(checkbox)
	return checkbox:GetChecked() and true or false
end